VERSION 5.00
Begin VB.Form Smp 
   Caption         =   "MPL-45 MCM Sample Program"
   ClientHeight    =   6840
   ClientLeft      =   120
   ClientTop       =   450
   ClientWidth     =   8775
   LinkTopic       =   "Form1"
   ScaleHeight     =   6840
   ScaleWidth      =   8775
   StartUpPosition =   3  'Windows ̊l
   Begin VB.CommandButton Command_PulseCounterReset 
      Caption         =   "PULSE COUNTER RESET"
      Height          =   495
      Left            =   5160
      TabIndex        =   19
      Top             =   6240
      Width           =   2415
   End
   Begin VB.Timer Timer1 
      Enabled         =   0   'False
      Interval        =   50
      Left            =   7200
      Top             =   5400
   End
   Begin VB.CommandButton Command_Close 
      Caption         =   "CLOSE"
      Height          =   495
      Left            =   120
      TabIndex        =   18
      Top             =   5520
      Width           =   2415
   End
   Begin VB.CommandButton Command_Open 
      Caption         =   "OPEN"
      Height          =   495
      Left            =   120
      TabIndex        =   17
      Top             =   4800
      Width           =   2415
   End
   Begin VB.CommandButton Command_Environment 
      Caption         =   "ENVIRONMENT"
      Height          =   495
      Left            =   120
      TabIndex        =   16
      Top             =   4080
      Width           =   2415
   End
   Begin VB.CommandButton Command_End 
      Caption         =   "END"
      Height          =   495
      Left            =   120
      TabIndex        =   15
      Top             =   6240
      Width           =   2415
   End
   Begin VB.CommandButton Command_MCMClearError 
      Caption         =   "MCM CLEAR ERROR"
      Height          =   495
      Left            =   2640
      TabIndex        =   14
      Top             =   6240
      Width           =   2415
   End
   Begin VB.CommandButton Command_MCMFastStop 
      Caption         =   "MCM FAST STOP"
      Height          =   495
      Left            =   5160
      TabIndex        =   13
      Top             =   5520
      Width           =   2415
   End
   Begin VB.CommandButton Command_MCMSlowStop 
      Caption         =   "MCM SLOW STOP"
      Height          =   495
      Left            =   2640
      TabIndex        =   12
      Top             =   5520
      Width           =   2415
   End
   Begin VB.CommandButton Command_MCMStart 
      Caption         =   "MCM START"
      Height          =   495
      Left            =   2640
      TabIndex        =   11
      Top             =   4800
      Width           =   2415
   End
   Begin VB.CommandButton Command_MCMRamWrite 
      Caption         =   "MCM RAM DATA WRITE"
      Height          =   495
      Left            =   5160
      TabIndex        =   10
      Top             =   4080
      Width           =   2415
   End
   Begin VB.CommandButton Command_MCMSheetDownload 
      Caption         =   "MCM SHEET DOWN LOAD"
      Height          =   495
      Left            =   2640
      TabIndex        =   9
      Top             =   4080
      Width           =   2415
   End
   Begin VB.Label Label_Message 
      Alignment       =   2  '
      BorderStyle     =   1  '
      Height          =   1815
      Left            =   2160
      TabIndex        =   8
      Top             =   2040
      Width           =   6495
   End
   Begin VB.Label Label8 
      Caption         =   "MESSAGE"
      Height          =   255
      Left            =   120
      TabIndex        =   7
      Top             =   2040
      Width           =   1935
   End
   Begin VB.Label Label7 
      Caption         =   "PULSE COUNTER"
      Height          =   255
      Left            =   120
      TabIndex        =   6
      Top             =   1680
      Width           =   1935
   End
   Begin VB.Label Label_PulseCounter 
      Alignment       =   2  '
      BorderStyle     =   1  '
      Height          =   255
      Left            =   2160
      TabIndex        =   5
      Top             =   1680
      Width           =   2295
   End
   Begin VB.Label Label_McmAddress 
      Alignment       =   2  '
      BorderStyle     =   1  '
      Height          =   255
      Left            =   2160
      TabIndex        =   4
      Top             =   1320
      Width           =   2295
   End
   Begin VB.Label Label4 
      Caption         =   "MCM ADDRESS"
      Height          =   255
      Left            =   120
      TabIndex        =   3
      Top             =   1320
      Width           =   1935
   End
   Begin VB.Label Label_McmStatus1 
      Alignment       =   2  '
      BorderStyle     =   1  '
      Height          =   255
      Left            =   2160
      TabIndex        =   2
      Top             =   960
      Width           =   2295
   End
   Begin VB.Label Label2 
      Caption         =   "MCM STATUS1"
      Height          =   255
      Left            =   120
      TabIndex        =   1
      Top             =   960
      Width           =   1935
   End
   Begin VB.Label Label1 
      Alignment       =   2  '
      BackColor       =   &H00FFFFFF&
      BorderStyle     =   1  '
      Caption         =   "X Axis - SHEET0 -"
      BeginProperty Font 
         Name            =   "lr oSVbN"
         Size            =   15.75
         Charset         =   128
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   495
      Left            =   120
      TabIndex        =   0
      Top             =   120
      Width           =   2655
   End
End
Attribute VB_Name = "Smp"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
'********************************************************************************************************************
'
'   MPL-45-02V2.00/AL2W32 VB MCM Sample Program                     5.5702.40.1510
'
'********************************************************************************************************************
Option Explicit

'********************************************************************************************************************
'
'   Definition of the variable
'
'********************************************************************************************************************
Dim hDev As Long                                                ' Device Handle
Dim hUnit As Long                                               ' Unit Handle
Dim RamWriteData(8) As MC07_S_COMMAND_DATA                      ' Ram Write Data

'********************************************************************************************************************
'
'   Initialize the Ram Write Data.( a to]and]fro motion)
'
'********************************************************************************************************************
Private Sub Initialize_RamWriteData()
    RamWriteData(0).Command = &H5                       'FSPD SET
    RamWriteData(0).Data = 5000
    RamWriteData(1).Command = &H6                       'HIGH SPEED SET
    RamWriteData(1).Data = 5000 Or (&H3 * (2 ^ 16))
    RamWriteData(2).Command = &H7                       'LOW SPEED SET
    RamWriteData(2).Data = 1000 Or (1000 * (2 ^ 16))
    RamWriteData(3).Command = &H8                       'RATE SET
    RamWriteData(3).Data = 200 Or (200 * (2 ^ 16))
    RamWriteData(4).Command = &H14                      'INC INDEX DRIVE
    RamWriteData(4).Data = 3000
    RamWriteData(5).Command = &H5                       'FSPD SET
    RamWriteData(5).Data = 10
    RamWriteData(6).Command = &H14                      'INC INDEX DRIVE
    RamWriteData(6).Data = -3000
    RamWriteData(7).Command = &H0                       'NO OPERATION
    RamWriteData(7).Data = &HFFFF
    RamWriteData(8).Command = &HBF                      'RAM STOP
    RamWriteData(8).Data = 0
End Sub

'********************************************************************************************************************
'
'   Setting the condition of the button in drive condition.
'
'********************************************************************************************************************
Private Sub ButtonDisable()
    Command_Environment.Enabled = False
    Command_Open.Enabled = False
    Command_Close.Enabled = False
    Command_End.Enabled = False
    Command_MCMSheetDownload.Enabled = False
    Command_MCMRamWrite.Enabled = False
    Command_MCMStart.Enabled = False
    Command_MCMSlowStop.Enabled = True
    Command_MCMFastStop.Enabled = True
    Command_MCMClearError.Enabled = False
    Command_PulseCounterReset.Enabled = False

End Sub

'********************************************************************************************************************
'
'   Setting the condition of the button in not drive condition.
'
'********************************************************************************************************************
Private Sub ButtonEnable()
    Command_Environment.Enabled = False
    Command_Open.Enabled = False
    Command_Close.Enabled = True
    Command_End.Enabled = False
    Command_MCMSheetDownload.Enabled = True
    Command_MCMRamWrite.Enabled = True
    Command_MCMStart.Enabled = True
    Command_MCMSlowStop.Enabled = True
    Command_MCMFastStop.Enabled = True
    Command_MCMClearError.Enabled = True
    Command_PulseCounterReset.Enabled = True

End Sub




'********************************************************************************************************************
'
'   The processing that Form was loaded.
'
'********************************************************************************************************************
Private Sub Form_Load()
    Label_Message.Caption = "Please environmental setting."
    Command_Environment.Enabled = True
    Command_Open.Enabled = False
    Command_Close.Enabled = False
    Command_End.Enabled = True
    Command_MCMSheetDownload.Enabled = False
    Command_MCMRamWrite.Enabled = False
    Command_MCMStart.Enabled = False
    Command_MCMSlowStop.Enabled = False
    Command_MCMFastStop.Enabled = False
    Command_MCMClearError.Enabled = False
    Command_PulseCounterReset.Enabled = False

End Sub

'********************************************************************************************************************
'
'   The processing that Form was unload.
'
'********************************************************************************************************************
Private Sub Form_Unload(Cancel As Integer)
    
    Dim sResult As MC07_S_RESULT
    Dim Ret As Boolean
    
    Ret = MC07_UClose(hUnit, sResult)
    
    Ret = MC07_BClose(hDev, sResult)
    
End Sub


'********************************************************************************************************************
'
'   The processing that the ENVIRONMENT Button was clicked.
'
'********************************************************************************************************************
Private Sub Command_Environment_Click()
    Dim sResult As MC07_S_RESULT

    Label_Message.Caption = ""
    
    If (MC07_Environment(MC07_AL2USB_USB_0, MC07_COMM_RATE_20, 3, sResult) = False) Then
        Label_Message.Caption = "It failed in MC07_Environment() : MC07_Result(2)=" & Str(sResult.MC07_Result(2)) & vbCrLf _
                                & "MC07_Result(3)=" & Str(sResult.MC07_Result(3))
        Exit Sub
    End If
        
    Label_Message.Caption = "Please Open the device."
    Command_Environment.Enabled = False
    Command_Open.Enabled = True
    Command_Close.Enabled = False
    Command_End.Enabled = True
    Command_MCMSheetDownload.Enabled = False
    Command_MCMRamWrite.Enabled = False
    Command_MCMStart.Enabled = False
    Command_MCMSlowStop.Enabled = False
    Command_MCMFastStop.Enabled = False
    Command_MCMClearError.Enabled = False
    Command_PulseCounterReset.Enabled = False
    
End Sub

'********************************************************************************************************************
'
'   The processing that the OPEN Button was clicked.
'
'********************************************************************************************************************
Private Sub Command_Open_Click()
    Dim sResult As MC07_S_RESULT
    Dim slaveInfo As MC07_S_SLAVE_INFO

    Label_Message.Caption = ""
    
    '*** READ SLAVE INFO ***
    If (MC07_ReadSlaveInfo(MC07_AL2USB_USB_0, slaveInfo, sResult) = False) Then
        Label_Message.Caption = "It failed in MC07_ReadUnitInfo() : MC07_Result(2)=" & Str(sResult.MC07_Result(2)) & vbCrLf _
                                & "MC07_Result(3)=" & Str(sResult.MC07_Result(3))
        Command_Environment.Enabled = True
        Exit Sub
    End If
    
    If (slaveInfo.SlaveType(1) = &HFF) Then
        Label_Message.Caption = "NO CONTROLLER UNIT SLAVE ADDRESS No.1" & vbCrLf & ":Please Check AL2 connection"
        Command_Environment.Enabled = True
        Exit Sub
    End If
    
    '*** UNIT OPEN ***
    If (MC07_UOpen(MC07_AL2USB_USB_0 Or MC07_SLAVE_1, hUnit, sResult) = False) Then
        Label_Message.Caption = "It failed to MC07_UOpen()  : MC07_Result(2)=" & Str(sResult.MC07_Result(2)) & vbCrLf _
                                & "MC07_Result(3)=" & Str(sResult.MC07_Result(3))
         Command_Environment.Enabled = True
       Exit Sub
    End If
    
    '*** DEVICE OPEN ***
    If (MC07_BOpen(MC07_AL2USB_USB_0 Or MC07_SLAVE_1, MC07_X, hDev, sResult) = False) Then
        Label_Message.Caption = "It failed to MC07_BOpen()  : MC07_Result(2)=" & Str(sResult.MC07_Result(2)) & vbCrLf _
                                & "MC07_Result(3)=" & Str(sResult.MC07_Result(3))
         Command_Environment.Enabled = True
       Exit Sub
    End If
        
    Timer1.Enabled = True
    
    Command_Environment.Enabled = False
    Command_Open.Enabled = False
    Command_Close.Enabled = True
    Command_End.Enabled = False
    Command_MCMSheetDownload.Enabled = True
    Command_MCMRamWrite.Enabled = True
    Command_MCMStart.Enabled = False
    Command_MCMSlowStop.Enabled = True
    Command_MCMFastStop.Enabled = True
    Command_MCMClearError.Enabled = True
    Command_PulseCounterReset.Enabled = True


End Sub


'********************************************************************************************************************
'
'   The processing that the CLOSE Button was clicked.
'
'********************************************************************************************************************
Private Sub Command_Close_Click()
    Dim sResult As MC07_S_RESULT

    Timer1.Enabled = False
    
    Label_Message.Caption = ""
    Label_McmStatus1.Caption = ""
    Label_McmAddress.Caption = ""
    Label_PulseCounter.Caption = ""
    
    
    '*** UNIT CLOSE ***
    If (MC07_UClose(hUnit, sResult) = False) Then
        Label_Message.Caption = "It failed in MC07_UClose() : MC07_Result(2)=" & Str(sResult.MC07_Result(2)) & vbCrLf _
                                & "MC07_Result(3)=" & Str(sResult.MC07_Result(3))
        Command_Environment.Enabled = True
        Exit Sub
    End If
    
    '*** DEVICE CLOSE ***
    If (MC07_BClose(hDev, sResult) = False) Then
        Label_Message.Caption = "It failed in MC07_BClose() : MC07_Result(2)=" & Str(sResult.MC07_Result(2)) & vbCrLf _
                                & "MC07_Result(3)=" & Str(sResult.MC07_Result(3))
        Command_Environment.Enabled = True
        Exit Sub
    End If
    
    Command_Environment.Enabled = True
    Command_Open.Enabled = True
    Command_Close.Enabled = False
    Command_End.Enabled = True
    Command_MCMSheetDownload.Enabled = False
    Command_MCMRamWrite.Enabled = False
    Command_MCMStart.Enabled = False
    Command_MCMSlowStop.Enabled = False
    Command_MCMFastStop.Enabled = False
    Command_MCMClearError.Enabled = False
    Command_PulseCounterReset.Enabled = False
    Label_Message.Caption = "Please open the device."

End Sub

'********************************************************************************************************************
'
'   The processing that the END Button was clicked.
'
'********************************************************************************************************************
Private Sub Command_End_Click()
    Unload Me
End Sub

'********************************************************************************************************************
'
'   The processing that the MCM SHEET DOWN LOAD Button was clicked.
'
'********************************************************************************************************************
Private Sub Command_MCMSheetDownload_Click()

    Dim sResult As MC07_S_RESULT
    Dim SheetNo As Integer
    
    Label_Message.Caption = ""
    If (UnitMcmStatusCheck() = False) Then
       Exit Sub
    End If
    
    SheetNo = 0
    '*** UNIT MCM SHEET DOWNLOAD ***
    If (False = MC07_UDownloadMcmSheet(hUnit, SheetNo, sResult)) Then
       Label_Message.Caption = "It failed to MC07_UDownloadMcmSheet()  : MC07_Result(2)=" & Str(sResult.MC07_Result(2)) & vbCrLf _
                                & "MC07_Result(3)=" & Str(sResult.MC07_Result(3))
       Exit Sub
    End If
    
    Label_Message.Caption = "Sheet 0 down load Succeed."
    Command_MCMStart.Enabled = True

End Sub


'********************************************************************************************************************
'
'   The processing that the MCM RAM DATA WRITE Button was clicked.
'
'********************************************************************************************************************
Private Sub Command_MCMRamWrite_Click()
    Dim sResult As MC07_S_RESULT
    Dim Spec As Integer
    Dim i As Integer
    
    Label_Message.Caption = ""
    
    Call Initialize_RamWriteData
    
    If (UnitMcmStatusCheck() = False) Then
       Exit Sub
    End If
    
    '*** MCM SPEC INITIALIZE0 ***
    'Because what access ram data is enable
    Spec = &H1
    If (False = MC07_USetMcmSpec0(hUnit, Spec, sResult)) Then
       Label_Message.Caption = "It failed to MC07_USetMcmSpec0()  : MC07_Result(2)=" & Str(sResult.MC07_Result(2)) & vbCrLf _
                           & "MC07_Result(3)=" & Str(sResult.MC07_Result(3))
       Exit Sub
    End If

    
    For i = 0 To 8
    
        If (XAxisMcmStatusCheck() = False) Then
            Exit Sub
        End If

        '*** UNIT MCM RAM WRITE ***
        If (False = MC07_UWriteMcmRam(hUnit, MC07_X, i, RamWriteData(i), sResult)) Then
            Label_Message.Caption = "It failed to MC07_UWriteMcmRam()  : MC07_Result(2)=" & Str(sResult.MC07_Result(2)) & vbCrLf _
                                & "MC07_Result(3)=" & Str(sResult.MC07_Result(3))
            Exit Sub
        End If
    Next
    
    Label_Message.Caption = "Write Ram Data Succeed."
    Command_MCMStart.Enabled = True
   

End Sub

'********************************************************************************************************************
'
'   The processing that the MCM START Button was clicked.
'
'********************************************************************************************************************
Private Sub Command_MCMStart_Click()
    Dim sResult As MC07_S_RESULT
    Dim UnitMcmStartData As MC07_S_UNIT_MCM_START_DATA
    Dim Cmd As Integer
    Dim LData As Long
    Dim sUnitMcmErrorStatus As MC07_S_UNIT_MCM_ERROR_STATUS
        
    Label_Message.Caption = ""
        
    'UNIT MCM ERROR STATUS READ
    If (MC07_UReadMcmErrorStatus(hUnit, MC07_SEL_X_Y_Z_A, sUnitMcmErrorStatus, sResult) = False) Then
         Label_Message.Caption = "It failed to MC07_UReadMcmStatus()  : MC07_Result(2)=" & Str(sResult.MC07_Result(2)) & vbCrLf _
                                & "MC07_Result(3)=" & Str(sResult.MC07_Result(3))
         Exit Sub
    End If
    
    '*** ERROR STATUS MASK COMMAND ***
    'FSSTOP ERROR MASK = 0
    'SLSTOP ERROR MASK = 0
    'LSEND ERROR MASK = 0
    Cmd = &HE5
    LData = sUnitMcmErrorStatus.X.MccErrorStatusMask And &HFDD9
    If (MC07_LWDrive(hDev, Cmd, LData, sResult) = False) Then
        Label_Message.Caption = "It failed in MC07_LWDrive(H'" & Hex(Cmd) & ") : MC07_Result(2)=" & Str(sResult.MC07_Result(2)) & vbCrLf _
                                & "MC07_Result(3)=" & Str(sResult.MC07_Result(3))
        Exit Sub
    End If
    
    If (XAxisMcmStatusCheck() = False) Then
       Exit Sub
    End If
    
    UnitMcmStartData.X.Address = 0
    '*** UNIT MCM START ***
    If (False = MC07_UStartMcm(hUnit, MC07_SEL_X, UnitMcmStartData, sResult)) Then
       Label_Message.Caption = "It failed to MC07_UStartMcm()  : MC07_Result(2)=" & Str(sResult.MC07_Result(2)) & vbCrLf _
                                & "MC07_Result(3)=" & Str(sResult.MC07_Result(3))
       Exit Sub
    End If

    Call ButtonDisable
    Call ReadyWait
    
    '*** ERROR STATUS MASK COMMAND ***
    'State before the MCM Start
    Cmd = &HE5
    LData = sUnitMcmErrorStatus.X.MccErrorStatusMask
    If (MC07_LWDrive(hDev, Cmd, LData, sResult) = False) Then
        Label_Message.Caption = "It failed in MC07_LWDrive(H'" & Hex(Cmd) & ") : MC07_Result(2)=" & Str(sResult.MC07_Result(2)) & vbCrLf _
                                & "MC07_Result(3)=" & Str(sResult.MC07_Result(3))
        Call ButtonEnable
        Exit Sub
    End If

    Call ButtonEnable
   

End Sub

'********************************************************************************************************************
'
'   The processing that the MCM SLOW STOP Button was clicked.
'
'********************************************************************************************************************
Private Sub Command_MCMSlowStop_Click()
    Dim sResult As MC07_S_RESULT
    
    Label_Message.Caption = ""
    '*** UNIT MCM SLSTOP ***
    If (False = MC07_USlstopMcm(hUnit, MC07_SEL_X, sResult)) Then
       Label_Message.Caption = "It failed to MC07_USlstopMcm()  : MC07_Result(2)=" & Str(sResult.MC07_Result(2)) & vbCrLf _
                                & "MC07_Result(3)=" & Str(sResult.MC07_Result(3))
       Exit Sub
    End If

End Sub

'********************************************************************************************************************
'
'   The processing that the MCM FAST STOP Button was clicked.
'
'********************************************************************************************************************
Private Sub Command_MCMFastStop_Click()
    Dim sResult As MC07_S_RESULT
    
    Label_Message.Caption = ""
    '*** UNIT MCM FSSTOP ***
    If (False = MC07_UFsstopMcm(hUnit, MC07_SEL_X, sResult)) Then
       Label_Message.Caption = "It failed to MC07_UFsstopMcm()  : MC07_Result(2)=" & Str(sResult.MC07_Result(2)) & vbCrLf _
                                & "MC07_Result(3)=" & Str(sResult.MC07_Result(3))
       Exit Sub
    End If

End Sub


'********************************************************************************************************************
'
'   The processing that the MCM CLEAR ERROR Button was clicked.
'
'********************************************************************************************************************
Private Sub Command_MCMClearError_Click()
    Dim sResult As MC07_S_RESULT
    
    Label_Message.Caption = ""
    
    '*** UNIT MCM ERROR CLR ***
    If (False = MC07_UClrMcmError(hUnit, MC07_SEL_X_Y_Z_A, sResult)) Then
       Label_Message.Caption = "It failed to MC07_UClrMcmError()  : MC07_Result(2)=" & Str(sResult.MC07_Result(2)) & vbCrLf _
                                & "MC07_Result(3)=" & Str(sResult.MC07_Result(3))
       Exit Sub
    End If
    
    Label_Message.Caption = "MC07_UClrMcmError() succeed"

End Sub

'********************************************************************************************************************
'
'   The processing that the PULSE COUNTER RESET Button was clicked.
'
'********************************************************************************************************************
Private Sub Command_PulseCounterReset_Click()
    Dim sResult As MC07_S_RESULT
    Dim Cmd As Integer
    Dim LData As Long

    Label_Message.Caption = ""
        
    '*** PULSE COUNTER PRESET ***
    Cmd = &H90
    LData = 0
    If (MC07_LWDrive(hDev, Cmd, LData, sResult) = False) Then
        Label_Message.Caption = "It failed in MC07_LWDrive(H'" & Hex(Cmd) & ") : MC07_Result(2)=" & Str(sResult.MC07_Result(2)) & vbCrLf _
                                & "MC07_Result(3)=" & Str(sResult.MC07_Result(3))
        Exit Sub
    End If

End Sub

'********************************************************************************************************************
'
'   The processing that Timer1 Enabled was true.
'
'********************************************************************************************************************
Private Sub Timer1_Timer()
    Dim sResult As MC07_S_RESULT
    Dim UnitMcmStatus As MC07_S_UNIT_MCM_STATUS
    Dim UnitMcmInfo As MC07_S_UNIT_MCM_INFO
    
    '*** UNIT MCM STATUS READ ***
    If (MC07_UReadMcmStatus(hUnit, MC07_SEL_X_Y_Z_A, UnitMcmStatus, sResult) = False) Then
        Label_Message.Caption = "It failed to MC07_UReadMcmStatus()  : MC07_Result(2)=" & Str(sResult.MC07_Result(2)) & vbCrLf _
                                & "MC07_Result(3)=" & Str(sResult.MC07_Result(3))
        Timer1.Enabled = False
        Command_Environment.Enabled = True
        Exit Sub
    End If
    
    Label_McmStatus1.Caption = "H'" & Hex(UnitMcmStatus.McmStatus1)
    Label_PulseCounter.Caption = CStr(UnitMcmStatus.X.Data)
    
    '*** UNIT MCM INFO READ ***
    If (MC07_UReadMcmInfo(hUnit, MC07_SEL_X_Y_Z_A, UnitMcmInfo, sResult) = False) Then
        Label_Message.Caption = "It failed to MC07_UReadMcmInfo()  : MC07_Result(2)=" & Str(sResult.MC07_Result(2)) & vbCrLf _
                                & "MC07_Result(3)=" & Str(sResult.MC07_Result(3))
        Timer1.Enabled = False
        Command_Environment.Enabled = True
        Exit Sub
    End If
    
    Label_McmAddress.Caption = CStr(UnitMcmInfo.X.Address)
 

End Sub

'********************************************************************************************************************
'
'   Check MCM STATUS1 All Axes MBUSY , MERR
'   Return : True  --- All Axes MBUSY = 0 and MERR = 0
'            False --- Some Axis MBUSY = 1 or MERR = 1
'
'********************************************************************************************************************
Private Function UnitMcmStatusCheck() As Boolean
    Dim sUnitMcmStatus As MC07_S_UNIT_MCM_STATUS
    Dim sUnitMcmErrorStatus As MC07_S_UNIT_MCM_ERROR_STATUS
    Dim sResult As MC07_S_RESULT
    Dim XMccErrorMaskData As Integer
    Dim YMccErrorMaskData As Integer
    Dim ZMccErrorMaskData As Integer
    Dim AMccErrorMaskData As Integer
    
    UnitMcmStatusCheck = False
    
    'UNIT MCM STATUS READ
    If (MC07_UReadMcmStatus(hUnit, MC07_SEL_X_Y_Z_A, sUnitMcmStatus, sResult) = False) Then
       Label_Message.Caption = "It failed to MC07_UReadMcmStatus()  : MC07_Result(2)=" & Str(sResult.MC07_Result(2)) & vbCrLf _
                                & "MC07_Result(3)=" & Str(sResult.MC07_Result(3))
       Exit Function
    End If
    
    If ((sUnitMcmStatus.McmStatus1 And &H5555) = &H0) Then
        UnitMcmStatusCheck = True
    Else
        
        'UNIT MCM ERROR STATUS READ
        If (MC07_UReadMcmErrorStatus(hUnit, MC07_SEL_X_Y_Z_A, sUnitMcmErrorStatus, sResult) = False) Then
            Label_Message.Caption = "It failed to MC07_UReadMcmErrorStatus()  : MC07_Result(2)=" & Str(sResult.MC07_Result(2)) & vbCrLf _
                                & "MC07_Result(3)=" & Str(sResult.MC07_Result(3))
            Exit Function
        End If
        
        'inverts a logic of MCC ERROR STATUS MASK data.
        XMccErrorMaskData = Not sUnitMcmErrorStatus.X.MccErrorStatusMask
        YMccErrorMaskData = Not sUnitMcmErrorStatus.Y.MccErrorStatusMask
        ZMccErrorMaskData = Not sUnitMcmErrorStatus.Z.MccErrorStatusMask
        AMccErrorMaskData = Not sUnitMcmErrorStatus.A.MccErrorStatusMask
                
        Label_Message.Caption = "MCM STATUS1 MERR = 1 or MBUSY = 1." & vbCrLf & _
                                "Cannot MCM operation" & vbCrLf & _
                                "X ErrorCode  = H'" & Hex(sUnitMcmErrorStatus.X.ErrorCode) & _
                                " : MccErrorStatus  =  H'" & Hex(sUnitMcmErrorStatus.X.MccErrorStatus And XMccErrorMaskData) & _
                                " : OriginErrorStatus  = H'" & Hex(sUnitMcmErrorStatus.X.OriginErrorStatus) & vbCrLf & _
                                "Y ErrorCode  = H'" & Hex(sUnitMcmErrorStatus.Y.ErrorCode) & _
                                " : MccErrorStatus  =  H'" & Hex(sUnitMcmErrorStatus.Y.MccErrorStatus And YMccErrorMaskData) & _
                                " : OriginErrorStatus  = H'" & Hex(sUnitMcmErrorStatus.Y.OriginErrorStatus) & vbCrLf & _
                                "Z ErrorCode  = H'" & Hex(sUnitMcmErrorStatus.Z.ErrorCode) & _
                                " : MccErrorStatus  =  H'" & Hex(sUnitMcmErrorStatus.Z.MccErrorStatus And ZMccErrorMaskData) & _
                                " : OriginErrorStatus  = H'" & Hex(sUnitMcmErrorStatus.Z.OriginErrorStatus) & vbCrLf & _
                                "A ErrorCode  = H'" & Hex(sUnitMcmErrorStatus.A.ErrorCode) & _
                                " : MccErrorStatus  =  H'" & Hex(sUnitMcmErrorStatus.A.MccErrorStatus And AMccErrorMaskData) & _
                                " : OriginErrorStatus  = H'" & Hex(sUnitMcmErrorStatus.A.OriginErrorStatus) & vbCrLf & _
                                "Please click 'MCM CLEAR ERROR'"
    End If
End Function

'********************************************************************************************************************
'
'   Check MCM STATUS1 X Axis MBUSY , MERR
'   Return : True  --- X Axis MBUSY = 0 and MERR = 0
'            False --- X Axis MBUSY = 1 or MERR = 1
'
'********************************************************************************************************************
Private Function XAxisMcmStatusCheck() As Boolean
    Dim sUnitMcmStatus As MC07_S_UNIT_MCM_STATUS
    Dim sUnitMcmErrorStatus As MC07_S_UNIT_MCM_ERROR_STATUS
    Dim sResult As MC07_S_RESULT
    Dim MccErrorMaskData As Integer
    
    XAxisMcmStatusCheck = False
    
    'UNIT MCM STATUS READ
    If (MC07_UReadMcmStatus(hUnit, MC07_SEL_X_Y_Z_A, sUnitMcmStatus, sResult) = False) Then
       Label_Message.Caption = "It failed to MC07_UReadMcmStatus()  : MC07_Result(2)=" & Str(sResult.MC07_Result(2)) & vbCrLf _
                                & "MC07_Result(3)=" & Str(sResult.MC07_Result(3))
       Exit Function
    End If
    
    If ((sUnitMcmStatus.McmStatus1 And &H5) = &H0) Then
        XAxisMcmStatusCheck = True
    Else
        
        'UNIT MCM ERROR STATUS READ
        If (MC07_UReadMcmErrorStatus(hUnit, MC07_SEL_X_Y_Z_A, sUnitMcmErrorStatus, sResult) = False) Then
            Label_Message.Caption = "It failed to MC07_UReadMcmErrorStatus()  : MC07_Result(2)=" & Str(sResult.MC07_Result(2)) & vbCrLf _
                                & "MC07_Result(3)=" & Str(sResult.MC07_Result(3))
            Exit Function
        End If
        'inverts a logic of MCC ERROR STATUS MASK data.
        MccErrorMaskData = Not sUnitMcmErrorStatus.X.MccErrorStatusMask
        
        Label_Message.Caption = "MCM STATUS1 X MERR = 1 or X MBUSY = 1." & vbCrLf & _
                                "Cannot MCM operation" & vbCrLf & _
                                "ErrorCode  = H'" & Hex(sUnitMcmErrorStatus.X.ErrorCode) & _
                                " : MccErrorStatus  =  H'" & Hex(sUnitMcmErrorStatus.X.MccErrorStatus And MccErrorMaskData) & _
                                " : OriginErrorStatus  = H'" & Hex(sUnitMcmErrorStatus.X.OriginErrorStatus) & vbCrLf & _
                                "Please click 'MCM CLEAR ERROR'"
    End If
    
End Function

'********************************************************************************************************************
'
'   Waits until MCM STATUS1 becomes ready condition. Meantime position address of motor is displayed.
'
'********************************************************************************************************************
Private Sub ReadyWait()
    Dim sResult As MC07_S_RESULT
    Dim MccErrorMaskData As Integer
    Dim sUnitMcmStatus As MC07_S_UNIT_MCM_STATUS
    Dim sUnitMcmErrorStatus As MC07_S_UNIT_MCM_ERROR_STATUS
    
    Do
        DoEvents
        '*** UNIT MCM STATUS READ ***
        If (MC07_UReadMcmStatus(hUnit, MC07_SEL_X_Y_Z_A, sUnitMcmStatus, sResult) = False) Then
                Label_Message.Caption = "It failed to MC07_UReadMcmStatus()  : MC07_Result(2)=" & Str(sResult.MC07_Result(2)) & vbCrLf _
                                & "MC07_Result(3)=" & Str(sResult.MC07_Result(3))
           Exit Sub
        End If
        
    Loop While ((sUnitMcmStatus.McmStatus1 And &H1) <> 0)
    
    If ((sUnitMcmStatus.McmStatus1 And &H4) = &H0) Then
        Label_Message.Caption = "Drive ended."
    Else
    
        
        'UNIT MCM ERROR STATUS READ
        If (MC07_UReadMcmErrorStatus(hUnit, MC07_SEL_X_Y_Z_A, sUnitMcmErrorStatus, sResult) = False) Then
            Label_Message.Caption = "It failed to MC07_UReadMcmErrorStatus()  : MC07_Result(2)=" & Str(sResult.MC07_Result(2)) & vbCrLf _
                                & "MC07_Result(3)=" & Str(sResult.MC07_Result(3))
            Exit Sub
        End If
        
        'inverts a logic of MCC ERROR STATUS MASK data.
        MccErrorMaskData = Not sUnitMcmErrorStatus.X.MccErrorStatusMask
        
        Label_Message.Caption = "MCM STATUS1 X MERR = 1." & vbCrLf & _
                                "ErrorCode  = H'" & Hex(sUnitMcmErrorStatus.X.ErrorCode) & _
                                " : MccErrorStatus  =  H'" & Hex(sUnitMcmErrorStatus.X.MccErrorStatus And MccErrorMaskData) & _
                                " : OriginErrorStatus  = H'" & Hex(sUnitMcmErrorStatus.X.OriginErrorStatus) & vbCrLf & _
                                "Please click 'MCM CLEAR ERROR'"
    End If

    
    
 End Sub
